package demo_bubble_dvt.view.bean;

import java.util.HashMap;

import javax.faces.event.ActionEvent;


import javax.faces.event.ValueChangeEvent;

import oracle.adf.model.BindingContext;

import oracle.adf.view.faces.bi.component.graph.UIGraph;

import oracle.adf.view.faces.bi.event.ClickEvent;
import oracle.adf.view.faces.bi.event.graph.SelectionEvent;

import oracle.adf.view.rich.component.rich.data.RichTable;

import oracle.binding.BindingContainer;
import oracle.binding.ControlBinding;
import oracle.binding.OperationBinding;

import oracle.adf.view.rich.component.rich.layout.RichPanelStretchLayout;
import oracle.adf.view.rich.context.AdfFacesContext;

import oracle.dss.dataView.Attributes;
import oracle.dss.dataView.ComponentHandle;

import oracle.dss.dataView.DataComponentHandle;

import org.apache.myfaces.trinidad.event.PollEvent;

public class LifeExpectancyBean {

    String selectedCountry = null;
    private boolean renderGraph = true;
    private boolean renderDetailGraph = false;
    private RichPanelStretchLayout panelStrech;

    public LifeExpectancyBean() {
        super();
    }

    public void onClick(ClickEvent clickEvent) {
        System.out.println("onClick()");
        ComponentHandle componentHandle = clickEvent.getComponentHandle();
        if (componentHandle instanceof DataComponentHandle) {
            DataComponentHandle handle = (DataComponentHandle)componentHandle;
            Attributes[] attr = (handle).getGroupAttributes();
            for (int i = 0; i < attr.length; i++) {
                Attributes a = attr[i];
                Object obj = a.getValue(a.ID_ATTRIBUTE);
                System.out.println("obj: "+obj+" class: "+obj.getClass());
                //Check if we have our ViewObject ID attribute
                if ("Country".equals(obj.toString())) {
                    System.out.println("====ID_ATTRIBUTE: " + a.getValue(a.ID_ATTRIBUTE));
                    selectedCountry = (String)a.getValue(a.ID_VALUE);
                    System.out.println("selectedCountry=" + selectedCountry);
                }
            }
        }
        //Do something interesting with selectedCountry
        BindingContainer bindingContainer = BindingContext.getCurrent().getCurrentBindingsEntry();
        OperationBinding operationBinding = bindingContainer.getOperationBinding("ExecuteWithParamsSelectedCountry");
        operationBinding.getParamsMap().put("p_year", null);
        operationBinding.getParamsMap().put("p_country", selectedCountry);
        operationBinding.execute();
        renderDetailGraph = true;
        renderGraph = false;
        AdfFacesContext.getCurrentInstance().addPartialTarget(panelStrech);
    }

    public void setSelectedCountry(String selectedCountry) {
        this.selectedCountry = selectedCountry;
    }

    public String getSelectedCountry() {
        return selectedCountry;
    }

    public void setRenderDetailGraph(boolean renderDetailGraph) {
        this.renderDetailGraph = renderDetailGraph;
    }

    public boolean isRenderDetailGraph() {
        return renderDetailGraph;
    }

    public void setRenderGraph(boolean renderGraph) {
        this.renderGraph = renderGraph;
    }

    public boolean isRenderGraph() {
        return renderGraph;
    }

    public void setPanelStrech(RichPanelStretchLayout panelStrech) {
        this.panelStrech = panelStrech;
    }

    public RichPanelStretchLayout getPanelStrech() {
        return panelStrech;
    }

    public void back(ActionEvent actionEvent) {
        renderDetailGraph = false;
        renderGraph = true;
        AdfFacesContext.getCurrentInstance().addPartialTarget(panelStrech);
    }
}
